// - global -------------------------------------------------------
 var screenCanvas, info;
 var run = true;
 var fps = 1000/30;
 var mouse = new Point();
 var ctx;
 var fire = false;
 var guard = false;
 var counter = 0;
 var score = 0;
 var message = '';

// - const --------------------------------------------------------
 var CHARA_COLOR = 'rgba(0, 0, 255, 1)';
 var CHARA_SHOT_COLOR = 'rgba(255, 255, 0, 1)';
 var CHARA_SHOT_MAX_COUNT = 10;
 var CHARA_BURST_COLOR = 'rgba(255, 94, 25, 1)';
 var CHARA_BURST_MAX_COUNT = 1;
 var ENEMY_COLOR = 'rgba(255, 0, 0, 1)';
 var ENEMY_MAX_COUNT = 100;
 var ENEMY_SHOT_COLOR = 'rgba(255, 0, 255, 1)';
 var ENEMY_SHOT_MAX_COUNT = 10000;
 var BOSS_COLOR = 'rgba(200, 0, 255, 0.9)';
 var BOSS_COLOR_2 = 'rgba(102, 0, 0, 0.9)';
 var BOSS_COLOR_3 = 'rgba(255, 51, 0, 0.9)';
 var BOSS_COLOR_4 = 'rgba(255, 0, 0, 0.9)';
 var BOSS_COLOR_5 = 'rgba(0, 0, 0, 0.9)';
 var BOSS_BIT_COLOR = 'rgba(0, 0, 0, 1)';
 var BOSS_BIT_COUNT = 15; 
 var BOSS_SHOT_COLOR = 'rgba(256, 256, 256, 1)';
 var BOSS_SHOT_MAX_COUNT = 1000;
 var k = 15;
 var CAPTAIN_COLOR = 'rgba(0, 153, 0, 1)';
 var CAPTAIN_MAX_COUNT = 5;
 var CAPTAIN_SHOT_COLOR = 'rgba(0, 0, 0, 1)';
 var CAPTAIN_SHOT_MAX_COUNT = 50;
 var CANON_SHOT_COLOR = 'rgba(71, 84, 68, 1)';
 var CANON1_SHOT_MAX_COUNT = 100;
 var CANON2_SHOT_MAX_COUNT = 100;
 var SHIELD_COLOR = 'rgba(51, 255, 204,0.5)';
 var SHIELD_MAX_COUNT = 1;
 var w = 3;
// - main ---------------------------------------------------------
 window.onload = function() {
 
 	// ėpϐ
 	 var i, j, m, l;
 	 var p = new Point();
 	 var q = new Point();
 	
 	// XN[̏
 	 screenCanvas = document.getElementById('screen');
 	 screenCanvas.width = 432;
 	 screenCanvas.height = 648;
 	
 	// @̏ʒȕC
 	mouse.x = screenCanvas.width / 2;
 	mouse.y = screenCanvas.height - 20;
 	// 2dReLXg
 	 ctx = screenCanvas.getContext('2d');
 	
 	// Cxg̓o^
 	 screenCanvas.addEventListener('mousemove', mouseMove, true);
 	 screenCanvas.addEventListener('mousedown', mouseDown, true);
 	 window.addEventListener('keydown', keyDown, true);
 	
 	// ̑̃Gg֘A
 	 info = document.getElementById('info');
 	 mail = document.getElementById('mail');
 	
 	// @
 	 var chara = new Character();
 	 chara.init(12, 30);
 	
 	// Vbg̏
 	 var charaShot = new Array(CHARA_SHOT_MAX_COUNT);
 	 for(i = 0; i < CHARA_SHOT_MAX_COUNT; i++){
 	 	charaShot[i] = new CharacterShot();
 	 }
 	
 	 var charaBurst = new Array(CHARA_BURST_MAX_COUNT);
 	 for(i = 0; i < CHARA_BURST_MAX_COUNT; i++){
 	 	charaBurst[i] = new CharacterBurst();
 	 }
 	 
 	 var shield = new Array(SHIELD_MAX_COUNT);
 	 for(i = 0; i < SHIELD_MAX_COUNT; i++){
 	 	shield[i] = new Shield();
 	 }
 	// Gl~[
 	var enemy = new Array(ENEMY_MAX_COUNT);
 	for(i = 0; i < ENEMY_MAX_COUNT; i++){
 		enemy[i] = new Enemy();
 	}
 	
 	// Gl~[Vbg
 	var enemyShot = new Array(ENEMY_SHOT_MAX_COUNT);
 	for(i = 0; i < ENEMY_SHOT_MAX_COUNT; i++){
 		enemyShot[i] = new EnemyShot();
 	}
 	
 	// {X
 	var boss = new Boss();
 	
 	var canon1 = new Canon1();
 	
 	var canon2 = new Canon2();
 	
 	// {XVbg
 	var bossShot = new Array(BOSS_SHOT_MAX_COUNT);
 	for(i = 0; i < BOSS_SHOT_MAX_COUNT; i++){
 		bossShot[i] = new BossShot();
 	}
 	
 	// {Xrbg
 	var bit = new Array(BOSS_BIT_COUNT);
 	for(i = 0; i < BOSS_BIT_COUNT; i++){
 		bit[i] = new Bit();
 	}
 	
 	var captain = new Array(CAPTAIN_MAX_COUNT);
 	for(i = 0; i < CAPTAIN_MAX_COUNT; i++){
 		captain[i] = new Captain();
 	}
 	
 	var captainShot = new Array(CAPTAIN_SHOT_MAX_COUNT);
 	for(i = 0; i < CAPTAIN_SHOT_MAX_COUNT; i++){
 		captainShot[i] = new CaptainShot();
 	}
 	
 	var canon1Shot = new Array(CANON1_SHOT_MAX_COUNT);
 	for(i = 0; i < CANON1_SHOT_MAX_COUNT; i++){
 		canon1Shot[i] = new CanonShot();
 	}
 	
 	var canon2Shot = new Array(CANON2_SHOT_MAX_COUNT);
 	for(i = 0; i < CANON2_SHOT_MAX_COUNT; i++){
 		canon2Shot[i] = new CanonShot();
 	}
 	
 	// _OĂяo
 	 (function(){
 		// JE^CNg
 		 counter++;
 		
 		// HTMLXV
 		 info.innerHTML = mouse.x + ' : ' + mouse.y;
 		
 		// screenNA
 		 ctx.clearRect(0, 0, screenCanvas.width, screenCanvas.height);
 		
 		// - @ ----------------------------------------------------------------------------------
 		
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		
 		// @̈ʒuݒ
 		 chara.position.x = mouse.x;
 		 chara.position.y = mouse.y;
 		
 		// @`pXݒ
 		 ctx.arc(chara.position.x, chara.position.y, chara.size, 0, Math.PI * 2, false);
 		
 		if(counter % 4 === 0){
 			// ׂĂ̎@Vbg𒲍
 		 	 for(i = 0; i < CHARA_SHOT_MAX_COUNT; i++){
 		 	 	// @Vbgɔ˂Ă邩`FbN
 		 	 	 if(!charaShot[i].alive){
 		 	 	 	// @VbgVKɃZbg
 		 	 	 	 charaShot[i].set(chara.position,5,10);
 		 	 	 	
 		 	 	 	// [v𔲂
 		 	 	 	 break;
 		 	 	 }
 		 	 }
 		 }
 		
 		if(fire){
 			// ׂĂ̎@Vbg𒲍
 			for(i = 0; i < CHARA_BURST_MAX_COUNT; i++){
 				// @Vbgɔ˂Ă邩`FbN
 				if(!charaBurst[i].alive){
 					charaBurst[i].set(chara.position,50,80,2.5);
 					break;
 				}
 			}
 			// tO~낵Ă
 			fire = false;
 		}
 		
 		if(guard && w >0){
 			for(i = 0; i < SHIELD_MAX_COUNT; i++){
 				if(!shield[i].alive){
 					shield[i].set(chara,30,40);
 					w--;
 					break;
 				}
 			}
 			guard = false;
 		}
 		
 		// @̐Fݒ肷
 		 ctx.fillStyle = CHARA_COLOR;
 		
 		// @`
 		 ctx.fill();
 		
 		// - @Vbg --------------------------------------------------------------
 		
 		// pX̐ݒJn
 		 ctx.beginPath();
 		
 		// ׂĂ̎@Vbg𒲍
 		 for(i = 0; i < CHARA_SHOT_MAX_COUNT; i++){
 		 	// @Vbgɔ˂Ă邩`FbN
 		 	 if(charaShot[i].alive){
 		 	 	// @Vbg𓮂
 		 	 	 charaShot[i].move();
 		 	 	
 		 	 	// @Vbg`pXݒ
 		 	 	 ctx.arc(
 		 	 	 	charaShot[i].position.x,
 		 	 	 	charaShot[i].position.y,
 		 	 	 	charaShot[i].size,
 		 	 	 	0, Math.PI * 2,false
 		 	 	 );
 		 	 	
 		 	 	// pX
 		 	 	 ctx.closePath();
 		 	 }
 		}
 		
 		// @Vbg̐Fݒ肷
 		ctx.fillStyle = CHARA_SHOT_COLOR;
 		
 		// @Vbg`
 		ctx.fill();
 		
 		ctx.beginPath();
 		
 		for(i = 0; i < SHIELD_MAX_COUNT; i++){
 			if(shield[i].alive){
 				shield[i].move();
 				
 				ctx.arc(
 					chara.position.x,
 					chara.position.y,
 					shield[i].size,
 					0, Math.PI * 2,false
 				);
 				
 				ctx.closePath();
 			}
 		}
 		
 		ctx.fillStyle = SHIELD_COLOR;
 		
 		ctx.fill();
 		
 		ctx.beginPath();
 		
 		// ׂĂ̎@Vbg𒲍
 		for(i = 0; i < CHARA_BURST_MAX_COUNT; i++){
 			// @Vbgɔ˂Ă邩`FbN
 			 if(charaBurst[i].alive){
 			 	// @Vbg𓮂
 			 	 charaBurst[i].move();
 			 	
 			 	// @Vbg`pXݒ
 			 	 ctx.arc(
 			 	 	charaBurst[i].position.x,
 			 	 	charaBurst[i].position.y,
 			 	 	charaBurst[i].size,
 			 	 	0, Math.PI * 2,false
 			 	 );
 			 	
 			 	// pX
 			 	 ctx.closePath();
 			 }
 		}
 		
 		// @Vbg̐Fݒ肷
 		ctx.fillStyle = CHARA_BURST_COLOR;
 		
 		// @Vbg`
 		ctx.fill();
 		
 		// - Gl~[̏oǗ ----------------------------------------------------------
 		// 100t[Ɉxo
 		 if(counter % 25 === 0 && score < 60){
 		 	// ׂẴGl~[𒲍
 		 	 for(i = 0; i < ENEMY_MAX_COUNT; i++){
 		 	 	// Gl~[̐tO`FbN
 		 	 	 if(!enemy[i].alive){
 		 	 	 	// ^Cv肷p[^Zo
 		 	 	 	 j = (counter % 75) / 25;
 		 	 	 	
 		 	 	 	// ^Cvɉďʒu߂
 		 	 	 	 var enemySize = Math.floor( (Math.random() * 11) + 20);
 		 	 	 	 p.x = Math.floor( (Math.random() * 385))
 		 	 	 	 p.y = Math.floor( (Math.random() * 385))
 		 	 	 	
 		 	 	 	// Gl~[VKɃZbg
 		 	 	 	 enemy[i].set(p, 1, enemySize, j);
 		 	 	 	
 		 	 	 	// 1̏ôŃ[v𔲂
 		 	 	 	 break;
 		 	 	 }
 		 	 }
 		 }
 		 if(counter % 20 === 0 && boss.life < 33 && score > 100){
 		 	// ׂẴGl~[𒲍
 		 	 for(i = 0; i < ENEMY_MAX_COUNT; i++){
 		 	 	// Gl~[̐tO`FbN
 		 	 	 if(!enemy[i].alive){
 		 	 	 	// ^Cvɉďʒu߂
 		 	 	 	 var enemySize = Math.floor( (Math.random() * 11) + 20);
 		 	 	 	 p.x = Math.floor( (Math.random() * 513))
 		 	 	 	 p.y = Math.floor( (Math.random() * 385))
 		 	 	 	
 		 	 	 	// Gl~[VKɃZbg
 		 	 	 	 enemy[i].set(p, 3, enemySize, 1);
 		 	 	 	
 		 	 	 	// 1̏ôŃ[v𔲂
 		 	 	 	 break;
 		 	 	 }
 		 	 }
 		 }
 		 if(counter % 500 === 0 && score < 45){
 		 	for(i = 0; i < CAPTAIN_MAX_COUNT; i++){
 		 		if(!captain[i].alive){
 		 			p.x = screenCanvas.width / 2;
 		 			p.y = -80;
 		 			captain[i].set(p, 60, 15);
 		 			break;
 		 		}
 		 	}
 		 }
 		 if(score === 59){
 		 	// 6000 _Ń{Xo
 		 	p.x = screenCanvas.width / 2;
 		 	p.y = -80;
 		 	boss.set(p, 100, 100);
 		 	
 		 	// Ƀrbgo
 		 	for(i = 0; i < BOSS_BIT_COUNT; i++){
 		 		j = 360 / BOSS_BIT_COUNT;
 		 		bit[i].set(boss, 25, 5, i * j);
 		 	}
 		 }
 		 if(boss.life === 60 && boss.alive){
 		 	p.x = screenCanvas.width * 11 / 12;
 		 	p.y = 25;
 		 	canon1.set(p, 20);
 		 	
 		 	p.x = screenCanvas.width * 1 / 12;
 		 	p.y = 25;
 		 	canon2.set(p, 20);
 		 }
 		// - V[Ǘ ------------------------------------------------------------------
 		// JE^[̒lɂăV[
 		switch(true){
 			// JE^[70菬
 			case counter < 70:
 				message = 'READY...';
 				break;
 			
 			// JE^[100菬
 			case counter < 100:
 				message = 'GO!';
 				break;
 			
 			// JE^[100傫
 			default:
 				message = '@';
 		
 		// - Gl~[ ---------------------------------------------------------------------
 		
 		// pX̐ݒJn
 		 ctx.beginPath();
 		
 		// ׂẴGl~[𒲍
 		 for(i = 0; i < ENEMY_MAX_COUNT; i++){
 		 	// Gl~[̐tO`FbN
 		 	 if(enemy[i].alive){
 		 	 	// Gl~[𓮂
 		 	 	 enemy[i].move();
 		 	 	
 		 	 	// Gl~[`pXݒ
 		 	 	 ctx.arc(
 		 	 	 	enemy[i].position.x,
 		 	 	 	enemy[i].position.y,
 		 	 	 	enemy[i].size,
 		 	 	 	0, Math.PI * 2, false
 		 	 	 );
 		 	 	
 		 	 	// Vbgłǂp[^̒l`FbN
 		 	 	if(enemy[i].param % Math.floor( (Math.random() * 6) + 25) === 0){
 		 	 		// Gl~[Vbg𒲍
 		 	 		for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 		 	 			if(!enemyShot[j].alive){
 		 	 				// Gl~[VbgVKɃZbg
 		 	 				p = enemy[i].position.distance(chara.position);
 		 	 				p.normalize();
 		 	 				enemyShot[j].set(enemy[i].position, p, 2.5, 7);
 		 	 				
 		 	 				// PôŃ[v𔲂
 		 	 				break;
 		 	 			}
 		 	 		}
 		 	 	}
 		 	 	
 		 	 	// pX
 		 	 	 ctx.closePath();
 		 	 }
 		 }
 		
 		// Gl~[̐Fݒ肷
 		 ctx.fillStyle = ENEMY_COLOR;
 		
 		// Gl~[`
 		 ctx.fill();
 		
 		// - Gl~[Vbg ----------------------------------------------------------
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// ׂẴGl~[Vbg𒲍
 		for(i = 0; i < ENEMY_SHOT_MAX_COUNT; i++){
 			// Gl~[Vbgɔ˂Ă邩`FbN
 			if(enemyShot[i].alive){
 				// Gl~[Vbg𓮂
 				enemyShot[i].move();
 				
 				// Gl~[Vbg`pXݒ
 				ctx.arc(
 					enemyShot[i].position.x,
 					enemyShot[i].position.y,
 					enemyShot[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// pX
 				ctx.closePath();
 			}
 		}
 		
 		// Gl~[Vbg̐Fݒ肷
 		ctx.fillStyle = ENEMY_SHOT_COLOR;
 		
 		// Gl~[Vbg`
 		ctx.fill();
 		
 		// - {XVbg -----------------------------------------------------------------
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// ׂẴGl~[Vbg𒲍
 		for(i = 0; i < BOSS_SHOT_MAX_COUNT; i++){
 			// Gl~[Vbgɔ˂Ă邩`FbN
 			if(bossShot[i].alive){
 				// Gl~[Vbg𓮂
 				bossShot[i].move();
 				
 				// Gl~[Vbg`pXݒ
 				ctx.arc(
 					bossShot[i].position.x,
 					bossShot[i].position.y,
 					bossShot[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// pX
 				ctx.closePath();
 			}
 		}
 		
 		// Gl~[Vbg̐Fݒ肷
 		ctx.fillStyle = BOSS_SHOT_COLOR;
 		
 		// Gl~[Vbg`
 		ctx.fill();
 		
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// ׂẴGl~[Vbg𒲍
 		for(i = 0; i < CAPTAIN_SHOT_MAX_COUNT; i++){
 			// Gl~[Vbgɔ˂Ă邩`FbN
 			if(captainShot[i].alive){
 				// Gl~[Vbg𓮂
 				captainShot[i].move();
 				
 				// Gl~[Vbg`pXݒ
 				ctx.arc(
 					captainShot[i].position.x,
 					captainShot[i].position.y,
 					captainShot[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// pX
 				ctx.closePath();
 			}
 		}
 		
 		// Gl~[Vbg̐Fݒ肷
 		ctx.fillStyle = CAPTAIN_SHOT_COLOR;
 		
 		// Gl~[Vbg`
 		ctx.fill();
 		
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		for(i = 0; i < CANON1_SHOT_MAX_COUNT; i++){
 			// Gl~[Vbgɔ˂Ă邩`FbN
 			if(canon1Shot[i].alive){
 				// Gl~[Vbg𓮂
 				canon1Shot[i].move();
 				
 				// Gl~[Vbg`pXݒ
 				ctx.arc(
 					canon1Shot[i].position.x,
 					canon1Shot[i].position.y,
 					canon1Shot[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// pX
 				ctx.closePath();
 			}
 		}
 		
 		// Gl~[Vbg̐Fݒ肷
 		ctx.fillStyle = CANON_SHOT_COLOR;
 		
 		// Gl~[Vbg`
 		ctx.fill();
 		
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		for(i = 0; i < CANON2_SHOT_MAX_COUNT; i++){
 			// Gl~[Vbgɔ˂Ă邩`FbN
 			if(canon2Shot[i].alive){
 				// Gl~[Vbg𓮂
 				canon2Shot[i].move();
 				
 				// Gl~[Vbg`pXݒ
 				ctx.arc(
 					canon2Shot[i].position.x,
 					canon2Shot[i].position.y,
 					canon2Shot[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// pX
 				ctx.closePath();
 			}
 		}
 		
 		// Gl~[Vbg̐Fݒ肷
 		ctx.fillStyle = CANON_SHOT_COLOR;
 		
 		// Gl~[Vbg`
 		ctx.fill();
 		// {X ---------------------------------------------------------------------------
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// {X̏otO`FbN
 		if(boss.alive){
 			// {X𓮂
 			boss.move();
 			
 			// {X`pXݒ
 			ctx.arc(
 				boss.position.x,
 				boss.position.y,
 				boss.size,
 				0, Math.PI * 2, false
 			);
 			
 			// Vbgłǂp[^̒l`FbN
 			 	if(boss.param % 12 === 0 && k === 0 && boss.life > 50){
 			 		// Gl~[Vbg𒲍
 			 		for(j = 0; j < BOSS_SHOT_MAX_COUNT; j++){
 			 			if(!bossShot[j].alive){
 			 				// Gl~[VbgVKɃZbg
 			 				p = boss.position.distance(chara.position);
 			 				p.normalize();
 			 				bossShot[j].set(boss.position, p, 15, 15);
 			 				
 			 				// PôŃ[v𔲂
 			 				break;
 			 			}
 			 		}
 			 	}
 			 	if(boss.param % 10 === 0 && k === 0 && boss.life < 51 && boss.life > 12){
 			 		// Gl~[Vbg𒲍
 			 		for(j = 0; j < BOSS_SHOT_MAX_COUNT; j++){
 			 			if(!bossShot[j].alive){
 			 				// Gl~[VbgVKɃZbg
 			 				p = boss.position.distance(chara.position);
 			 				p.normalize();
 			 				bossShot[j].set(boss.position, p, 22.5, 15);
 			 				
 			 				// PôŃ[v𔲂
 			 				break;
 			 			}
 			 		}
 			 	}
 			 	if(boss.param % 10 === 0 && k === 0 && boss.life < 13){
 			 		// Gl~[Vbg𒲍
 			 		for(j = 0; j < BOSS_SHOT_MAX_COUNT; j++){
 			 			if(!bossShot[j].alive){
 			 				// Gl~[VbgVKɃZbg
 			 				p = boss.position.distance(chara.position);
 			 				p.normalize();
 			 				bossShot[j].set(boss.position, p, 30, 22.5);
 			 				
 			 				// PôŃ[v𔲂
 			 				break;
 			 			}
 			 		}
 			 	}
 			 	if(boss.param % 25 === 0 && boss.life < 75){
 			 		p = boss.position.distance(chara.position);
 			 		p.normalize();
 			 		m = 0;
 			 		for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 			 			if(!enemyShot[j].alive){
 			 				q.x = p.x;
 			 				q.y = p.y;
 			 				l = (360 + (m - 2) * 20) % 360;
 			 				q.rotate(l * Math.PI / 180);
 			 				enemyShot[j].set(boss.position, q, 2.5, 2.5);
 			 				m++;
 			 				if(m > 17){break;}
 			 			}
 			 		}
 			 	}
 			// pX
 			ctx.closePath();
 		}
 		
 		// {X̐Fݒ肷
 		if(boss.life > 74){
 			ctx.fillStyle = BOSS_COLOR;
 		}
 		if(boss.life > 49 && boss.life < 75){
 			ctx.fillStyle = BOSS_COLOR_2;
 		}
 		if(boss.life > 32 && boss.life < 50){
 			ctx.fillStyle = BOSS_COLOR_3;
 		}
 		if(boss.life < 33 && boss.life > 12){
 			ctx.fillStyle = BOSS_COLOR_4;
 		}
 		if(boss.life < 13){
 			ctx.fillStyle = BOSS_COLOR_5;
 		}
 		// {X`
 		ctx.fill();
 		//----------------------------------------------------------------------
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// {X̏otO`FbN
 		for(i = 0; i < CAPTAIN_MAX_COUNT; i++){
 			if(captain[i].alive){
 				// {X𓮂
 				captain[i].move();
 				
 				// {X`pXݒ
 				ctx.arc(
 					captain[i].position.x,
 					captain[i].position.y,
 					captain[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// Vbgłǂp[^̒l`FbN
 				if(captain[i].param % 15 === 0){
 			 			// Gl~[Vbg𒲍
 			 			for(j = 0; j < CAPTAIN_SHOT_MAX_COUNT; j++){
 			 				if(!captainShot[j].alive){
 			 					// Gl~[VbgVKɃZbg
 			 					p = captain[i].position.distance(chara.position);
 			 					p.normalize();
 			 					captainShot[j].set(captain[i].position, p, 10, 10);
 			 					
 			 					// PôŃ[v𔲂
 			 					break;
 			 				}
 			 			}
 			 		}
 				// pX
 				ctx.closePath();
 				}
 		}
 		
 		// {X̐Fݒ肷
 		ctx.fillStyle = CAPTAIN_COLOR;
 		
 		// {X`
 		ctx.fill();
 		// rbg ------------------------------------------------------------------------
 		// pX̐ݒJn
 		ctx.beginPath();
 		
 		// ׂẴrbg𒲍
 		for(i = 0; i < BOSS_BIT_COUNT; i++){
 			// rbg̏otO`FbN
 			if(bit[i].alive){
 				// rbg𓮂
 				bit[i].move();
 				
 				// rbg`pXݒ
 				ctx.arc(
 					bit[i].position.x,
 					bit[i].position.y,
 					bit[i].size,
 					0, Math.PI * 2, false
 				);
 				
 				// Vbgłǂp[^̒l`FbN
 		 	 	if(bit[i].param % 40 === 0 && k > 4){
 		 	 		// Gl~[Vbg𒲍
 		 	 		for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 		 	 			if(!enemyShot[j].alive){
 		 	 				// Gl~[VbgVKɃZbg
 		 	 				p = bit[i].position.distance(chara.position);
 		 	 				p.normalize();
 		 	 				enemyShot[j].set(bit[i].position, p, 2.5, 2.5);
 		 	 				
 		 	 				// PôŃ[v𔲂
 		 	 				break;
 		 	 			}
 		 	 		}
 		 	 	}
 		 	 	
 		 	 	if(bit[i].param % 10 === 0 && k < 5){
 		 	 		// Gl~[Vbg𒲍
 		 	 		for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 		 	 			if(!enemyShot[j].alive){
 		 	 				// Gl~[VbgVKɃZbg
 		 	 				p = bit[i].position.distance(chara.position);
 		 	 				p.normalize();
 		 	 				enemyShot[j].set(bit[i].position, p, 2.5, 3.8);
 		 	 				
 		 	 				// PôŃ[v𔲂
 		 	 				break;
 		 	 			}
 		 	 		}
 		 	 	}
 		 	 	
 		 	 	// pX
 		 	 	ctx.closePath();
 		 	 }
 		 }
 		 
 		 // rbg̐Fݒ肷
 		 ctx.fillStyle = BOSS_BIT_COLOR;
 		 
 		 // rbg`
 		 ctx.fill();
 		 
 		 //- -----------------------------------------------------------------------------
 		 if(canon1.alive){
 		 	ctx.fillRect(
 		 		canon1.position.x - 20,
 		 		canon1.position.y - 20,
 		 		40,40
 		 	);
 		 	
 		 	canon1.move();
 		 	
 		 	if(canon1.param % 80 === 0){
 					// Gl~[Vbg𒲍
 					for(j = 0; j < CANON1_SHOT_MAX_COUNT; j++){
 						if(!canon1Shot[j].alive){
 							// Gl~[VbgVKɃZbg
 							p = canon1.position.distance(chara.position);
 							p.normalize();
 							canon1Shot[j].set(canon1.position, p, 60, 2.5);
 							
 							// PôŃ[v𔲂
 							break;
 						}
 					}
 			}
 		}
 		
 		if(canon2.alive){
 		 	ctx.fillRect(
 		 		canon2.position.x - 20,
 		 		canon2.position.y - 20,
 		 		40,40
 		 	);
 		 	
 		 	canon2.move();
 		 	
 		 	if(canon2.param % 10 === 0){
 				// Gl~[Vbg𒲍
 				for(j = 0; j < CANON2_SHOT_MAX_COUNT; j++){
 					if(!canon2Shot[j].alive){
 						// Gl~[VbgVKɃZbg
 						p = canon2.position.distance(chara.position);
 						p.normalize();
 						canon2Shot[j].set(canon2.position, p, 2.5, 60);
 						
 						// PôŃ[v𔲂
 						break;
 					}
 				}
 			}
 			ctx.fillStyle = BOSS_COLOR;
 		}
 		
 		// - Փ˔ --------------------------------------------------------------------
 		// ׂĂ̎@Vbg𒲍
 		for(i = 0; i < CHARA_SHOT_MAX_COUNT; i++){
 			// @Vbg̐tO`FbN
 			if(charaShot[i].alive){
 				// @VbgƃGl~[Ƃ̏Փ˔
 				for(j = 0; j < ENEMY_MAX_COUNT; j++){
 					// Gl~[̐tO`FbN
 					if(enemy[j].alive){
 						// Gl~[Ǝ@VbgƂ̋v
 						p = enemy[j].position.distance(charaShot[i].position);
 						if(p.length() < enemy[j].size){
 							// Փ˂Ă琶tO~낷
 							enemy[j].life--;
 							if(enemy[j].life < 0){
 								enemy[j].alive = false;
 								
 								// XRAXV邽߂ɃCNg
 								score++;
 							}
 							// Փ˂̂Ń[v𔲂
 							break;
 						}
 					}
 				}
 				
 				// @VbgƃGl~[Ƃ̏Փ˔
 				for(j = 0; j < CAPTAIN_MAX_COUNT; j++){
 					// Gl~[̐tO`FbN
 					if(captain[j].alive){
 						// Gl~[Ǝ@VbgƂ̋v
 						p = captain[j].position.distance(charaShot[i].position);
 						if(p.length() < captain[j].size){
 							// Փ˂ĂϋvlfNg
 							captain[j].life--;
 							
 							// @Vbg̐tO~낷
 							charaShot[i].alive = false;
	 						
	 						// ϋvl}CiXɂȂ琶tO~낷
	 						if(captain[j].life < 0){
	 							captain[j].alive = false;
	 							if(score < 55){
	 								score += 5;
	 							}
	 						}
 							
 							// Փ˂̂Ń[v𔲂
 							break;
 						}
 					}
 				}
 				// @Vbgƃ{XrbgƂ̏Փ˔
 				for(j = 0; j < BOSS_BIT_COUNT; j++){
 					// rbg̐tO`FbN
 					if(bit[j].alive){
 						// rbgƎ@VbgƂ̋v
 						p = bit[j].position.distance(charaShot[i].position);
 						if(p.length() < bit[j].size){
 							// Փ˂ĂϋvlfNg
 							bit[j].life--;
 							
 							// @Vbg̐tO~낷
 							charaShot[i].alive = false;
	 						
	 						// ϋvl}CiXɂȂ琶tO~낷
	 						if(bit[j].life < 0){
	 							bit[j].alive = false;
	 							score += 10;
	 							k -= 1;
	 						}
	 						
	 						// Փ˂̂Ń[v𔲂
	 						break;
	 					}
	 				}
	 			}
	 			
	 			// {X̐tO`FbN
	 			if(boss.alive){
	 				// @Vbgƃ{XƂ̏Փ˔
	 				p = boss.position.distance(charaShot[i].position);
	 				if(p.length() < boss.size){
	 					if(k === 0){
							// Փ˂ĂϋvlfNg
							boss.life--;
	 						
	 						// @Vbg̐tO~낷
	 						charaShot[i].alive = false;
	 						
	 						// ϋvl}CiXɂȂNA
	 						if(boss.life < 0){
	 							score += 50;
	 							score += chara.life * 300;
	 							score += Math.trunc(5000000 / counter);
	 							run = false;
	 							message = 'CLEAR !!';
	 						}
	 					}
	 				}
	 			}
 			}
 		}
 		for(i = 0; i < CHARA_BURST_MAX_COUNT; i++){
 			// @Vbg̐tO`FbN
 			if(charaBurst[i].alive){
 				// @VbgƃGl~[Ƃ̏Փ˔
 				for(j = 0; j < ENEMY_MAX_COUNT; j++){
 					// Gl~[̐tO`FbN
 					if(enemy[j].alive){
 						// Gl~[Ǝ@VbgƂ̋v
 						p = enemy[j].position.distance(charaBurst[i].position);
 						if(p.length() - 100 < enemy[j].size){
 							// Փ˂Ă琶tO~낷
 							enemy[j].life--;
 							if(enemy[j].life < 0){
 								enemy[j].alive = false;
 								
 								// XRAXV邽߂ɃCNg
 								score++;
 							}
 							// Փ˂̂Ń[v𔲂
 							break;
 						}
 					}
 				}
 				
 				// @VbgƃGl~[Ƃ̏Փ˔
 				for(j = 0; j < CAPTAIN_MAX_COUNT; j++){
 					// Gl~[̐tO`FbN
 					if(captain[j].alive){
 						// Gl~[Ǝ@VbgƂ̋v
 						p = captain[j].position.distance(charaBurst[i].position);
 						if(p.length() - 100 < captain[j].size + 10){
 							// Փ˂ĂϋvlfNg
 							captain[j].life -= 5;
 							
 							charaBurst[i].alive = false;
	 						
	 						// ϋvl}CiXɂȂ琶tO~낷
	 						if(captain[j].life < 0){
	 							captain[j].alive = false;
	 							if(score < 55){
	 								score += 5;
	 							}
	 						}
 							// Փ˂̂Ń[v𔲂
 							break;
 						}
 					}
 				}
 				// @Vbgƃ{XrbgƂ̏Փ˔
 				for(j = 0; j < BOSS_BIT_COUNT; j++){
 					// rbg̐tO`FbN
 					if(bit[j].alive){
 						// rbgƎ@VbgƂ̋v
 						p = bit[j].position.distance(charaBurst[i].position);
 						if(p.length() - 100 < bit[j].size){
 							bit[j].life--;
 							charaBurst[i].life -= 20;
	 						
	 						// ϋvl}CiXɂȂ琶tO~낷
	 						if(bit[j].life < 0){
	 							bit[j].alive = false;
	 							score += 10;
	 							k -= 1;
	 						}
	 						if(charaBurst[i].life < 0){
	 							charaBurst[i].alive = false;
	 						}
	 						
	 						// Փ˂̂Ń[v𔲂
	 						break;
	 					}
	 				}
	 			}
	 			// {X̐tO`FbN
	 			if(boss.alive){
	 				// @Vbgƃ{XƂ̏Փ˔
	 				p = boss.position.distance(charaBurst[i].position);
	 				if(p.length() - 100 < boss.size){
	 					if(k === 0){
							// Փ˂ĂϋvlfNg
							boss.life -= 2;
	 						
	 						// @Vbg̐tO~낷
	 						charaBurst[i].alive = false;
	 						
	 						// ϋvl}CiXɂȂNA
	 						if(boss.life < 0){
	 							score += 50;
	 							score += chara.life * 300;
	 							score += Math.trunc(5000000 / counter);
	 							run = false;
	 							message = 'CLEAR !!';
	 						}
	 					}
	 				}
	 			}
	 			for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 					// Gl~[̐tO`FbN
 					if(enemyShot[j].alive){
 						// Gl~[Ǝ@VbgƂ̋v
 						p = enemyShot[j].position.distance(charaBurst[i].position);
 						if(p.length() - 100 < enemyShot[j].size){
 							// Փ˂Ă琶tO~낷
 							enemyShot[j].alive = false;
 							charaBurst[i].life -= 3;
 							
	 						if(charaBurst[i].life < 0){
	 							charaBurst[i].alive = false;
 							}
 							// Փ˂̂Ń[v𔲂
 							break;
 							}
 						}
 					}
 				}
 			}
 		}
 		
 		for(i = 0; i < SHIELD_MAX_COUNT; i++){
 			if(shield[i].alive){
 				for(j = 0; j < ENEMY_SHOT_MAX_COUNT; j++){
 					if(enemyShot[j].alive){
 						p = enemyShot[j].position.distance(chara.position);
 						if(p.length() - 40 < enemyShot[j].size){
 							enemyShot[j].alive = false;
 							shield[i].life--;
 							
 							if(shield[i].life < 0){
 								shield[i].alive = false;
 							}
 							
 							break;
 						}
 					}
 				}
 				
 				for(j = 0; j < CAPTAIN_SHOT_MAX_COUNT; j++){
 					if(captainShot[j].alive){
 						p = captainShot[j].position.distance(chara.position);
 						if(p.length() - 40 < captainShot[j].size){
 							captainShot[j].alive = false;
 							shield[i].life -= 3;
 							
 							if(shield[i].life < 0){
 								shield[i].alive = false;
 							}
 							
 							break;
 						}
 					}
 				}
 				
 				for(j = 0; j < BOSS_SHOT_MAX_COUNT; j++){
 					if(bossShot[j].alive){
 						p = bossShot[j].position.distance(chara.position);
 						if(p.length() - 40 < bossShot[j].size){
 							bossShot[j].alive = false;
 							shield[i].life -= 10;
 							
 							if(shield[i].life < 0){
 								shield[i].alive = false;
 							}
 							
 							break;
 						}
 					}
 				}
 				
 				for(j = 0; j < CANON1_SHOT_MAX_COUNT; j++){
 					if(canon1Shot[j].alive){
 						p = canon1Shot[j].position.distance(chara.position);
 						if(p.length() - 40 < canon1Shot[j].size){
 							canon1Shot[j].alive = false;
 							shield[i].life -= 3;
 							
 							if(shield[i].life < 0){
 								shield.alive = false;
 							}
 							
 							break;
 						}
 					}
 				}
 				
 				for(j = 0; j < CANON2_SHOT_MAX_COUNT; j++){
 					if(canon2Shot.alive){
 						p = canon2Shot[j].position.distance(chara.position);
 						if(p.length() - 40 < canon2Shot[j].size){
 							canon2Shot[j].alive = false;
 							shield[i].life -= 3;
 							
 							if(shield[i].life < 0){
 								shield[i].alive = false;
 							}
 							
 							break;
 						}
 					}
 				}
 			}
 		}
 		
 		for(i = 0; i < ENEMY_SHOT_MAX_COUNT; i++){
 			if(enemyShot[i].alive){
 				p = chara.position.distance(enemyShot[i].position);
 				if(p.length() < chara.size){
 					chara.life--;
 					
 					enemyShot[i].alive = false;
 					
 					if(chara.life < 1){
 						chara.life = 0;
 						chara.alive = false;
 						run = false;
 						message = 'GAME OVER !!';
 					}
 					break;
 				}
 			}
 		}
 		
 		for(i = 0; i < BOSS_SHOT_MAX_COUNT; i++){
 			if(bossShot[i].alive){
 				p = chara.position.distance(bossShot[i].position);
 				if(p.length() - bossShot[i].size < chara.size){
 					chara.life -= 7;
 					
 					bossShot[i].alive = false;
 					
 					if(chara.life < 1){
 						chara.life = 0;
 						chara.alive = false;
 						run = false;
 						message = 'GAME OVER !!';
 					}
 					break;
 				}
 			}
 		}
 		for(i = 0; i < CAPTAIN_SHOT_MAX_COUNT; i++){
 			if(captainShot[i].alive){
 				p = chara.position.distance(captainShot[i].position);
 				if(p.length() - captainShot[i].size < chara.size){
 					chara.life -= 4;
 					
 					captainShot[i].alive = false;
 					
 					if(chara.life < 1){
 						chara.life = 0;
 						chara.alive = false;
 						run = false;
 						message = 'GAME OVER !!';
 					}
 					break;
 				}
 			}
 		}
 		for(i = 0; i < CANON1_SHOT_MAX_COUNT; i++){
 			if(canon1Shot[i].alive){
 				p = chara.position.distance(canon1Shot[i].position);
 				if(p.length() - canon1Shot[i].size < chara.size){
 					chara.life -= 4;
 					
 					canon1Shot[i].alive = false;
 					
 					if(chara.life < 1){
 						chara.life = 0;
 						chara.alive = false;
 						run = false;
 						message = 'GAME OVER !!';
 					}
 					break;
 				}
 			}
 		}
 		for(i = 0; i < CANON2_SHOT_MAX_COUNT; i++){
 			if(canon2Shot[i].alive){
 				p = chara.position.distance(canon2Shot[i].position);
 				if(p.length() - canon2Shot[i].size < chara.size){
 					chara.life -= 4;
 					
 					canon2Shot[i].alive = false;
 					
 					if(chara.life < 1){
 						chara.life = 0;
 						chara.alive = false;
 						run = false;
 						message = 'GAME OVER !!';
 					}
 					break;
 				}
 			}
 		}
 		if(counter > 4100){
 			chara.alive = false;
 			run = false;
 			message = 'TIME OVER !!';
 		}
 		//----------------------------------------------------------
 		
 		var clock = Math.trunc((counter - 100)/10);
		if(counter < 100){
			time = 400;
		} else {
			time = 400 - clock;
		}
		for(i = 0; i < CHARA_BURST_MAX_COUNT; i++){
		if(charaBurst[i].alive){
			cooler = '~@';
		} else {
			cooler = 'OK!!@';
		}
		break;
		}
 		
 		info.innerHTML = ' <div id="score">@SCORE:</div><div id="scorenum"> ' + (score * 100) + ' </div><br><br> ' + ' <div id="life">@LIFE:</div><div id="lifecount"><p id="lifenum"> ' + chara.life + ' </p><p id="lifemax">/ 30</p></div><br><br><br><div id="time"><div id="count">@TIME:</div><br><div id="counter"> ' + time + ' </div><br><br><br><div id="burst">@BURST:</div><br><div id="check"> ' + cooler@ + ' </div><br><br><br> ' + ' <div id="shield">@SHIELD:</div><div id="shieldcount"><p id="shieldnum"> ' + w + ' </p><p id="shieldmax">/ 3</p></div></div> ';
 		mail.innerHTML = message;
 		// tOɂċAĂяo
 		 if(run){setTimeout(arguments.callee, fps);}
 	})();
 };
  
// - event --------------------------------------------------------
 function mouseMove(event){
 	// }EXJ[\W̍XV
 	 mouse.x = event.clientX - screenCanvas.offsetLeft;
 	 mouse.y = event.clientY - screenCanvas.offsetTop;
 }
 
 function keyDown(event){
 	// L[R[h擾
 	 var ck = event.keyCode;
 	
 	// EscL[ĂtO~낷
 	 if(ck === 27){alert("PAUSE");}
 	 
 	if(ck === 115){
 		guard = true;
 	}
 }
 
 function mouseDown(event){
 	// tO𗧂Ă
 	 fire = true;
 }