// - boss -----------------------------------------------------------------------------------------------------
function Boss(){
	this.position = new Point();
	this.size = 0;
	this.life = 0;
	this.param = 0;
	this.alive = false;
}

Boss.prototype.set = function(p,size,life){
	// WZbg
	this.position.x = p.x;
	this.position.y = p.y;
	
	// TCYAϋvlZbg
	this.size = size;
	this.life = life;
	
	// p[^Zbg
	this.param = 0;
	
	// tO𗧂Ă
	this.alive = true;
};

Boss.prototype.move = function(){
	var i, j;
	// p[^CNg
	this.param++;
	
	// p[^ɉĕ
	switch(true){
		case this.param < 200:
			// ɂ܂i
			this.position.y += 1.5;
			break;
		default:
			// p[^烉WA߂
			i = ((this.param - 200) % 360) * Math.PI / 180;
			
			//WA牡ړʂZo
			j = screenCanvas.width / 2;
			this.position.x = j + Math.sin(i) * j;
			break;
	}
};
function BossShot(){
	this.position = new Point();
	this.vector = new Point();
	this.size = 0;
	this.speed = 0;
	this.alive = false;
}

BossShot.prototype.set = function(p, vector, size, speed){
	// WAxNgZbg
	this.position.x = p.x;
	this.position.y = p.y;
	this.vector.x = vector.x;
	this.vector.y = vector.y;
	
	// TCYAXs[hZbg
	this.size = size;
	this.speed = speed;
	
	// tO𗧂Ă
	this.alive = true;
};

BossShot.prototype.move = function(){
	// WxNgɉspeedړ
	this.position.x += this.vector.x * this.speed;
	this.position.y += this.vector.y * this.speed;
	
	// ȏ̍WɓBĂ琶tO~낷
	if(
		this.position.x < -this.size ||
		this.position.y < -this.size ||
		this.position.x > this.size + screenCanvas.width ||
		this.position.y > this.size + screenCanvas.height
	){
		this.alive = false;
	}
};

//- captain --------------------------------------------------------------------------------
function Captain(){
	this.position = new Point();
	this.size = 0;
	this.life = 0;
	this.param = 0;
	this.alive = false;
}

Captain.prototype.set = function(p,size,life){
	// WZbg
	this.position.x = p.x;
	this.position.y = p.y;
	
	// TCYAϋvlZbg
	this.size = size;
	this.life = life;
	
	// p[^Zbg
	this.param = 0;
	
	// tO𗧂Ă
	this.alive = true;
};

Captain.prototype.move = function(){
	var i, j;
	// p[^CNg
	this.param++;
	
	// p[^ɉĕ
	switch(true){
		case this.param < 50:
			// ɂ܂i
			this.position.y += 5;
			break;
		default:
			// p[^烉WA߂
			i = ((this.param - 250) % 360) * Math.PI / 180;
			
			//WA牡ړʂZo
			j = screenCanvas.width / 2;
			this.position.x = j + Math.sin(i) * j * 1.2;
			break;
	}
};

function CaptainShot(){
	this.position = new Point();
	this.vector = new Point();
	this.size = 0;
	this.speed = 0;
	this.alive = false;
}

CaptainShot.prototype.set = function(p, vector, size, speed){
	// WAxNgZbg
	this.position.x = p.x;
	this.position.y = p.y;
	this.vector.x = vector.x;
	this.vector.y = vector.y;
	
	// TCYAXs[hZbg
	this.size = size;
	this.speed = speed;
	
	// tO𗧂Ă
	this.alive = true;
};

CaptainShot.prototype.move = function(){
	// WxNgɉspeedړ
	this.position.x += this.vector.x * this.speed;
	this.position.y += this.vector.y * this.speed;
	
	// ȏ̍WɓBĂ琶tO~낷
	if(
		this.position.x < -this.size ||
		this.position.y < -this.size ||
		this.position.x > this.size + screenCanvas.width ||
		this.position.y > this.size + screenCanvas.height
	){
		this.alive = false;
	}
};

// - boss bit -------------------------------------------------------------------------------------------------------------
function Bit(){
	this.position = new Point();
	this.parent = null;
	this.size = 0;
	this.life = 0;
	this.param = 0;
	this.alive = false;
}

Bit.prototype.set = function(parent, size, life, param){
	// ̂ƂȂ{XZbg
	this.parent = parent;
	
	// TCYAϋvlZbg
	this.size = size;
	this.life = life;
	
	// p[^ɏlZbg
	this.param = param;
	
	// tO𗧂Ă
	this.alive = true;
};

Bit.prototype.move = function(){
	var i, x, y;
	
	// p[^CNg
	this.param++;
	
	// p[^烉WA߂
	i = (this.param % 360) * Math.PI / 180;
	
	// WA牡ړʂ߂
	x = Math.cos(i) * (this.parent.size + this.size);
	y = Math.sin(i) * (this.parent.size + this.size);
	this.position.x = this.parent.position.x + x;
	this.position.y = this.parent.position.y + y;
};

function Canon1(){
	this.position = new Point();
	this.size = 0;
	this.param = 0;
	this.alive = false;
}

Canon1.prototype.set = function(p,size){
	// WZbg
	this.position.x = p.x;
	this.position.y = p.y;
	
	// TCYAϋvlZbg
	this.size = size;
	
	// p[^Zbg
	this.param = 0;
	
	// tO𗧂Ă
	this.alive = true;
};

Canon1.prototype.move = function(){

	this.param++;

};

function Canon2(){
	this.position = new Point();
	this.size = 0;
	this.param = 0;
	this.alive = false;
}

Canon2.prototype.set = function(p,size){
	// WZbg
	this.position.x = p.x;
	this.position.y = p.y;
	
	// TCYAϋvlZbg
	this.size = size;
	
	// p[^Zbg
	this.param = 0;
	
	// tO𗧂Ă
	this.alive = true;
};

Canon2.prototype.move = function(){

	this.param++;

};

function CanonShot(){
	this.position = new Point();
	this.vector = new Point();
	this.size = 0;
	this.speed = 0;
	this.alive = false;
}

CanonShot.prototype.set = function(p, vector, size, speed){
	// WAxNgZbg
	this.position.x = p.x;
	this.position.y = p.y;
	this.vector.x = vector.x;
	this.vector.y = vector.y;
	
	// TCYAXs[hZbg
	this.size = size;
	this.speed = speed;
	
	// tO𗧂Ă
	this.alive = true;
};

CanonShot.prototype.move = function(){
	// WxNgɉspeedړ
	this.position.x += this.vector.x * this.speed;
	this.position.y += this.vector.y * this.speed;
	
	// ȏ̍WɓBĂ琶tO~낷
	if(
		this.position.x < -this.size ||
		this.position.y < -this.size ||
		this.position.x > this.size + screenCanvas.width ||
		this.position.y > this.size + screenCanvas.height
	){
		this.alive = false;
	}
};
